echo off
rem   PLOT1 file
rem   This batch file uses the HPLOT program to make a plot as a background
rem   job. The HPLOT program outputs HPGL plotter commands to the file HP.DAT;
rem   this file is then printed to a plotter connected to COM1 using the DOS
rem   PRINT command.  The MODE command is used to set the baud rate of COM1
rem   and to redirect printer output to COM1.
rem
rem   NOTE: Use this batch file to make only one plot at a time unless
rem         you have a plotter that automatically loads the paper such as
rem         the HP 7550 plotter.  Also note that a 3-D plot can result in
rem         a very large HP.DAT file (as large as .5 MB).

echo.
echo.WARNING: Make only one plot at a time unless using an HP 7550 plotter.
echo.

if exist hp.dat del hp.dat

hplot %1 hp.dat
if errorlevel 1 goto end

rem Set COM1 port to 9600 baud, No parity, 8 data bits, 1 stop bit, Printer
mode COM1:9600,N,8,1,P

mode LPT1:=COM1:
print hp.dat

echo.
echo. NOTE: To re-enable your printer after the plot has been drawn
echo.       type the following DOS command:
echo.
echo.                MODE LPT1:
echo.

:end
